<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="250px" style="margin: 0 12rem;">
        <!-- Botón regresar -->
        <ReturnButton v-on:clickEvent="viewList" title="Regresar" :offsetArrow="21" :spanTitle="2" class="text-end" style="margin-bottom: 2.5rem"></ReturnButton>
        <!-- Botón Editar -->
        <div class="text-end" style="margin-bottom: 1.5rem">
          <el-button class="text-orange btn-edit-report" @click="viewRev()">Editar </el-button>
        </div>

        <!-- Título -->
        <el-card class="report-title">
          <el-row type="flex" justify="space-between">
            <el-col :span="12">{{ material.originalTitle }}</el-col>
          </el-row>          
        </el-card>
      </el-header>

     <el-row style="margin: 3rem 15rem;" v-if="material.reviewObj.userLogin">
        <el-col :span="6">
          <h3 class="bolt-light" >REVISADO POR: </h3>     
        </el-col>
            <el-col :span="10">
              <el-row :span="24" v-for="(item, index) in userReview" :key="index" style="margin-top: 1rem">
              <el-col :span="17" class="text-bold" >{{ item.user }}
              </el-col>
              <el-col :span="7"> ({{ item.date }})
              </el-col>
            </el-row>          
        </el-col>
      </el-row> 

      <el-main style="margin: 0 12rem;">
        <h3 class="text-orange" style="margin: 0 0 2rem">DATOS DEL MATERIAL</h3>
        <!-- Código del material, código del contrato -->
        <el-row style="margin-bottom: 1rem">
          <el-col :span="12" v-if="material.codMaterial">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>CÓDIGO DEL MATERIAL</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.codMaterial}}</span>
              </el-col>
            </div>
          </el-col>
          <el-col :span="12" v-if="material.contractCode">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>CÓDIGO DEL CONTRATO</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.contractCode}}</span>
              </el-col>
            </div>
          </el-col>
        </el-row>         
        <!-- Títulos del material y Proveedor y producción -->
        <el-row style="margin-bottom: 1rem">
					<el-col :span="12">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>TÍTULOS DEL MATERIAL</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Título Original:</span>
                <span>{{material.originalTitle}}</span>
              </el-col>
							<el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Título Español y/o Sugerido:</span>
                <span>{{material.ownTitle}}</span>
              </el-col>
							<el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Título Comercial:</span>
                <span>{{material.listTitle}}</span>
              </el-col>
            </div>
          </el-col>
          <el-col :span="12">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>PROVEEDOR Y PRODUCCIÓN</strong>
            </el-col>
            <el-row class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Proveedor:</span>
                <span>{{material.providerName}}</span>
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Productora:</span>
                <span>
                  <span v-for="(item, index) in material.reviewObj.arrProdCompany" :key="index"
                    style="margin-bottom:0.5rem">
                    {{item.prodCompany}}<span v-if="index < (material.reviewObj.arrProdCompany.length -1)">, </span>
                  </span>
                </span>
              </el-col>
              <el-col :span="24" class="row-info-rev">
                <span class="fonts-bold-general">Año de Producción:</span>
                <span>{{material.reviewObj.yearProduction}}</span>
              </el-col>
            </el-row>
					</el-col>
				</el-row>
      
				<!-- Duración y resolución del material -->
				<el-row style="margin-bottom: 1rem">
					<el-col :span="12">
						<el-col :span="24" class="info-title-rev"> 
							<i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
							<strong>DURACIÓN Y BLOQUES</strong>
						</el-col>
						<el-row class="box-info-rev">
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Duración:</span>

                <span v-if="timeDuration[0] == ''"> 0h </span>
                <span v-else> {{timeDuration[0]}} h </span>
                <span v-if="timeDuration[1] == ''"> 0min </span>
                <span v-else> {{timeDuration[1]}} min  </span>
                <span v-if="timeDuration[2] == ''"> 0s </span>
                <span v-else> {{timeDuration[2]}} s </span>


							</el-col>
							<el-col :span="24" class="row-info-rev">
								<span class="fonts-bold-general">Bloques:</span>
								<span>{{material.reviewObj.blocks}}</span>
							</el-col>
						</el-row>
					</el-col>
					<el-col :span="12">
						<el-col :span="24" class="info-title-rev"> 
							<i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
							<strong>ETIQUETAS</strong>
						</el-col>
						<div class="box-info-rev">
							<el-col :span="24" class="row-info-rev">
								<el-tag v-for="(item, index) in material.reviewObj.dynamicTags"
									:key="index" type="info">
									{{item}}
								</el-tag>
							</el-col>
						</div>
					</el-col>
				</el-row>
        <!-- Estado de Emision -->
        <el-row style="margin-bottom: 1rem">
          <el-col :span="12">
            <el-col :span="24" class="info-title-rev"> 
              <i class="el-icon-edit" style="font-size: 22px; color: #828282"></i>
              <strong>ESTADO DE EMISIÓN</strong>
            </el-col>
            <div class="box-info-rev">
              <el-col :span="24" class="row-info-rev">
                <span>{{material.reviewObj.emissionStatus}}</span>
              </el-col>
            </div>
          </el-col>
        </el-row>
        <hr class="line-report" v-if="supportInfo.length > 0">

        <h3 class="text-orange" style="margin: 4rem 0 2rem" v-if="supportInfo.length > 0">DATOS DE SOPORTE</h3>
				<el-row v-if="supportInfo.length > 0">
					<el-col :span="16" :offset="2">
						<el-table 
							:data="supportInfo"
							:header-cell-class-name="tableRowClassName" border>
							<el-table-column
								label="FECHA DE LLEGADA">
								<template slot-scope="scope">
									<div style="margin-left: 10px">
										<p>{{ new Date(scope.row.arrivalDate).toLocaleDateString('en-GB') }}</p>
									</div>
								</template>
							</el-table-column>
							<el-table-column
								prop="shippingMode"
								label="MODO DE ENVÍO">
							</el-table-column>
							<el-table-column
								prop="supportOption"
								label="SOPORTE">
							</el-table-column>
						</el-table>
					</el-col>
				</el-row>
      </el-main>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import ReturnButton from '@/components/ReturnButton.vue'
import {HTTP} from '../../main.js'

export default {
  components: {
    ReturnButton
  },
  data () {
    return {
			timeDuration: '',
      supportInfo: [],
			// ----------
      material: {},
      stateObs: 0,
      dialogTableVisible: false,
      previousInfor: {},
      userLogin: localStorage.getItem('userName'),
      reposicionMsg: 'En espera de Reposición',
      totalMaterialsInContract: 0,
      positionIn : "",
      userReview: [],
    }
  },
  created () {
    this.materialObj()
    if(this.material.reviewObj.duration !== undefined) {
    this.timeDuration = this.material.reviewObj.duration.split(":")
    }
    if(this.material.supportObj !== undefined){
      this.supportInfo.push(this.material.supportObj)
    }
  },
  methods: {
    materialObj () {
      let observations = JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.observations
      this.userReview = JSON.parse(this.$localStorage.get("selectedMaterial")).reviewObj.userLogin

      if(observations) {
        for (var i = 0; i < observations.length; i++) {
          if (observations[i].status === 'En espera de Reposición') {
            this.stateObs++
          }
        }
      }
      

      this.material = JSON.parse(this.$localStorage.get("selectedMaterial"))
    },
    viewList () {
      
      let routePart = this.material.materialType;
      let cannedView = localStorage.getItem('cannedView')
      if(routePart == 'Películas'){
        routePart = 'Largometrajes'
      } else if(routePart == 'Programas Especiales'){
        routePart = 'specials'
      } else if(routePart == 'Especial'){
        routePart = 'specials'
      } else if(routePart == 'Producción Nacional') {
        switch(this.material.typeOfContent) {
          case 'Especial':
            routePart = 'fusionGourmet'
          break;
          case 'Novelas':
            routePart = 'novels'
          break;
          case 'Dibujos':
            routePart = 'cartoons'
          break;
          case 'Series':
            routePart = 'series'
          break;
          case 'Largometrajes':
            routePart = 'largometrajes'
          break;
          case 'Miniseries':
            routePart = 'miniseries'
          break;
          default:
            routePart = 'fusionGourmet'
          break;
        }
      }
      else{
        routePart = this.material.materialType == 'Fusión Gourmet' ? 'fusionGourmet' : this.material.materialType.toLowerCase();
      }

      let cannedShow;
      if(cannedView == 'true'){
        cannedShow = true;
      } else {
        cannedShow = false;
      }
      this.$router.push({ name: routePart, params: { canned: cannedShow, name: this.material.typeOfContent } });
    },
    viewRev () {
      this.$router.push({name: 'revisionNacional'})
    },
    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-light-red';
      }
    },
    handleEdit (index, row) {
      this.previousInfor = row
    }
  }
}
</script>
